%define anolis_release 1
%define debug_package %{nil}
%define python3_pkgversion 38
%define python3_bin python3.8

Name:	        he-toolkit	
Version:	2.0.1
Release:        %{anolis_release}%{?dist}
Summary:	Intel HE Toolkit

License:	Apache License 2.0
URL:		https://github.com/intel/he-toolkit
Source0:	https://github.com/intel/he-toolkit/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  cmake, 	gcc-toolset-12-gcc, gcc-toolset-12-gcc-c++
BuildRequires:  gcc-toolset-12-libstdc++-devel 
BuildRequires:  gcc-toolset-12-annobin-plugin-gcc
BuildRequires:  hexl-devel, seal-devel, helib-devel, palisade-devel
BuildRequires:  microsoft-gsl-devel 	libzstd-static
BuildRequires:  python%{python3_pkgversion}-devel python%{python3_pkgversion}-setuptools
BuildRequires:  gflags-devel
BuildRequires:  python%{python3_pkgversion}-scikit-learn python%{python3_pkgversion}-numpy
BuildRequires:	python%{python3_pkgversion}-scipy python%{python3_pkgversion}-joblib
BuildRequires:	python%{python3_pkgversion}-threadpoolctl
BuildRequires:  ntl-devel gmp-devel
Requires:       glibc
Requires:       helib-devel seal-devel ntl-devel hexl-devel palisade-devel
Requires:       gmp-devel

Patch1001:	1001-bugfix-the-error-in-check-the-python3-version.patch
Patch1002:	1002-remove-third-part-of-ext_gflags.patch
Patch1003:	1003-remove-pip-requires-in-datasets.patch
Patch1004:	1004-fix-the-link-error-in-build.patch
Patch1005:	1005-fix-the-files-install-error.patch
Patch1006:	1006-change-the-python3-to-python3.8.patch
Patch0001:	0001-change-the-datasets-path.patch

ExclusiveArch:  x86_64

%description
Intel HE Toolkit Package

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
source /opt/rh/gcc-toolset-12/enable
pushd he-samples/examples/logistic-regression
%cmake
%cmake_build
popd
pushd he-samples/examples/secure-query
%cmake
%cmake_build
popd
pushd he-samples/examples/psi
%cmake
%cmake_build
popd

%install
pushd he-samples/examples/logistic-regression
%cmake_install
popd
pushd he-samples/examples/secure-query
%cmake_install
popd
pushd he-samples/examples/psi
%cmake_install
popd

chmod 0755 %{buildroot}/%{_bindir}/lr_test
chmod 0755 %{buildroot}/%{_bindir}/psi
chmod 0755 %{buildroot}/%{_bindir}/secure-query

%files
%license LICENSE
%{_bindir}/lr_test
%{_bindir}/psi
%{_bindir}/secure-query
%{_datadir}/he-toolkit

%files doc
%doc README.md CODEOWNERS

%changelog
* Fri Nov 18 2022 xhuan28 <xiaojun.huang@intel.com> - 2.0.1-1
- Init package
